package graphs.amgraph;

import java.util.*; 
import graphs.*;

/**
 * Adjacency Matrix implementation of undirected graph
 *
 * @author V.B.
 * @version 2.0.0 Dec 2001
 */
public class UndirectedGraphAM extends GraphAM {
  
  /**
   * Constructs an empty graph.
   */         
  public UndirectedGraphAM() {
  	super();
  }
  
  /**
   * Constructs a graph using the passed matrix representation.
   *
   * @param vertices  the graph vertices
   */
  public UndirectedGraphAM(ArrayList vertices) {
    super(vertices);
  }
	
  /** Overrides the GraphAM method to insert a undirected edge */
  public void insertEdge(int i, int j, Object o) {
  	graphEdges[i][j] = new Edge(o);
  	graphEdges[j][i] = graphEdges[i][j];
  	numEdges++;
  }
  
  /** Removes edge e. */
  public void removeEdge(Edge e) {
  	for(int i = 0; i < numVertices; i++) {
  		for(int j = 0; j < numVertices; j++) {
    		if ((graphEdges[i][j]!=null) && (graphEdges[i][j].equals(e))) {
    			graphEdges[i][j]=null;
    			graphEdges[j][i]=null;
    			numEdges--;
    			break;
    		} 
      }
  	}
  }
	

  
}//to do: error conditions that may occur