package graphs.traversal;

import graphs.*;
import java.util.Hashtable;
import java.util.Iterator;

/** 
 * Represents the depth-first search in an undirected graph. 
 *
 * @version 1.1.0 Dec 2001
 */
public class DFS extends Traversal {

	/**
   * Recursive depth-first search starting at vertex v.
   */
  public Object visit(Vertex v) {
    initResult();
    startVisit(v);
    mark(v);
    
    //check all incident edges
    for (Iterator inEdges = graph.incidentEdges(v); inEdges.hasNext(); ) {
      Edge nextEdge = (Edge) inEdges.next();
      
      if (!isMarked(nextEdge)) {
        //found an unexplored edge, explore it
        mark(nextEdge);
        
        Vertex w = graph.opposite(v, nextEdge);
        if (!isMarked(w)) {
          //w is unexplored, this is a discovery edge
          mark(w);
          traverseDiscovery(nextEdge, v);
          if (!isDone()) {
            visitResult = visit(w);
          }
        } else {
          //w is explored, this is a back edge
          traverseBack(nextEdge, v);
        }
      }
    }
    finishVisit(v);
    return result();
  }
  
  protected void initResult() {}
  
  protected void startVisit(Vertex v) {}
  
  protected void traverseDiscovery(Edge e, Vertex from) {}
  
  protected void traverseBack(Edge e, Vertex from) {}
  
  protected void finishVisit(Vertex v) {}
  
  public Object result() {
    return new Object();
  }
  
    
}